#include <fstream>
using namespace std;

ifstream fin("tabla.in");
ofstream fout("tabla.out");

const int dx[]={0,-1,0,1,0};
const int dy[]={0,0,1,0,-1};

int interior(int x, int y);
int nr_sus(int i,int j,int val);
int nr_jos(int i,int j,int val);
int nr_st(int i,int j,int val);
int nr_dr(int i,int j,int val);
void schimba(int x,int y, int i, int j);


int a[51][51],n,mx,s,p,p1;

int main()
{
    int i,j,k,i1,j1;
    fin>>n;
    for(i=1;i<=n;i++)
    for(j=1;j<=n;j++)
        fin>>a[i][j];
    int v1,v2,v3,v4,v5,v6;
    for(i=1;i<=n;i++)
    for(j=1;j<=n;j++)
        for(k=1;k<=4;k++)
        {
            i1=i+dx[k];j1=j+dy[k];
            if(interior(i1,j1) && a[i][j]!=a[i1][j1])
            {
                if(k==1)
                    {
                    schimba(i,j,i1,j1);
                    v1=nr_sus(i1,j1,a[i1][j1]);
                    v2=nr_st(i1,j1,a[i1][j1]);
                    v3=nr_dr(i1,j1,a[i1][j1]);

                    v4=nr_jos(i,j,a[i][j]);
                    v5=nr_dr(i,j,a[i][j]);
                    v6=nr_st(i,j,a[i][j]);

                    schimba(i1,j1,i,j);
                    }
                if(k==2)
                    {
                    schimba(i,j,i1,j1);
                    v1=nr_dr(i1,j1,a[i1][j1]);
                    v2=nr_sus(i1,j1,a[i1][j1]);
                    v3=nr_jos(i1,j1,a[i1][j1]);

                    v4=nr_st(i,j,a[i][j]);
                    v5=nr_sus(i,j,a[i][j]);
                    v6=nr_jos(i,j,a[i][j]);

                    schimba(i,j,i1,j1);
                    }
                if(k==3)
                    {
                    schimba(i,j,i1,j1);
                    v1=nr_jos(i1,j1,a[i1][j1]);
                    v2=nr_st(i1,j1,a[i1][j1]);
                    v3=nr_dr(i1,j1,a[i1][j1]);

                    v4=nr_sus(i,j,a[i][j]);
                    v5=nr_st(i,j,a[i][j]);
                    v6=nr_dr(i,j,a[i][j]);

                    schimba(i,j,i1,j1);
                    }
                if(k==4)
                    {
                    schimba(i,j,i1,j1);
                    v1=nr_st(i1,j1,a[i1][j1]);
                    v2=nr_sus(i1,j1,a[i1][j1]);
                    v3=nr_jos(i1,j1,a[i1][j1]);

                    v4=nr_dr(i,j,a[i][j]);
                    v5=nr_sus(i,j,a[i][j]);
                    v6=nr_jos(i,j,a[i][j]);

                    schimba(i,j,i1,j1);
                    }

                p=0; p1=0;
                if((v1>=2) && (v2+v3)>=2)
                    p=5+v1-2+v2+v3-2;
                else if(v1>=2)
                        p=1+v1-2;
                     else if((v2+v3)>=2)
                            p=1+v2+v3-2;


                if((v4>=2) && (v5+v6)>=2)
                    p1=5+v4-2+v5+v6-2;
                else if(v4>=2)
                        p1=1+v4-2;
                     else if((v5+v6)>=2)
                            p1=1+v5+v6-2;

                if((p+p1)>mx)
                    mx=p+p1;

            }
        }
    fout<<mx;
    return 0;
}

void schimba(int x,int y, int i, int j)
{
    int aux=a[i][j];
    a[i][j]=a[x][y];
    a[x][y]=aux;
}
int nr_sus(int i,int j,int val)
{
    int l,c,p=0;
    l=i-1;
    while(l>0 && a[l][j]==val)
        p++,l--;
    return p;
}

int nr_jos(int i,int j,int val)
{
    int l,c,p=0;
    l=i+1;
    while(l<=n && a[l][j]==val)
        p++,l++;
    return p;

}

int nr_st(int i,int j,int val)
{

    int l,c,p=0;
    c=j-1;
    while(c>0 && a[i][c]==val)
        p++,c--;
    return p;
}
int nr_dr(int i,int j,int val)
{
    int l,c,p=0;
    c=j+1;
    while(c<=n && a[i][c]==val)
        p++,c++;
    return p;
}

int interior(int x, int y)
{
    return x>0 && x<n+1 && y>0 && y<n+1;
}
