//prof. Marinel Serban
//ianuarie 2014
//solutia verifica punctele care cad pe un lot prin testarea semnului
//fata de dreapta determinata de 2 puncte (o latura a lotului)
#include <fstream>
#include <cmath>

using namespace std;

long G, nrl;
long A, B, C;

struct pct        //record Punct
{
    int x, y;
};

typedef pct lot[101]; //retine structura lot

lot L[101];       //loturile
pct g[2000];      //retine grindina
int nrp[101];     //si cate puncte are fiecare

lot LM;           //lot manevra
long M;           //manevra
pct m[2000];      //manevra

int GpeL[101], cateMmax, cate0, Mmax;

ifstream fin ("grindina.in");
ofstream fout ("grindina.out");

void citire()
{
    int i, j;

    fin >> nrl;                   //cate loturi sunt
    for (i = 1; i <= nrl; i++)    //pentru fiecare lot
    {
        fin >> nrp[i];            //cate puncte il delimiteaza
        for (j = 1; j <= nrp[i]; j++) //citesc punctele
            fin >> L[i][j].x >> L[i][j].y;

        L[i][nrp[i] + 1] = L[i][1];  //adaug cele doua puncte
        L[i][nrp[i] + 2] = L[i][2];  //
    }
    fin >> G;                     //cata grindina
    for (i = 1; i <= G; i++)      //unde
        fin >> g[i].x >> g[i].y;
}

void dreapta (pct a, pct b)
{   //calculeaza coeficientii A, B, C ai dreptei ce trece
    //prin punctele a si b
    A = b.y - a.y;
    B = a.x - b.x;
    C = b.x * a.y - a.x * b.y;
}

int semn (pct x)
{   //determina de ce parte a dreptei Ax+By+C=0 este punctul x
    long v;

    v = A * x.x + B * x.y + C;
    if (v < 0)
        return -1;   //la stanga
    else if (v > 0)
        return 1;    //la dreapta
    else
        return 0;    //pe dreapta
}

void eliminare (int j)
{   //elimina punctul
    m[j] = m[M];
    M--;           //apoi micsoram numarul de puncte ramase
}

void numara (int l)
{   //calculeaza cata grindina cade pe un lot
    int i, s, j;

    for (i = 1; i <= nrp[l]; i++)
    {
        dreapta (LM[i], LM[i+1]);    //calculez coeficientii dreptei suport
        s = semn (LM[i+2]);          //stiu ca poligoanele sunt convexe
        if (s != 0)                  //deci punctul urmator imi da pozitia
            for (j = 1; j <= M; j++) //verific punctele ramase - initial toate
                if (semn (m[j]) != s)//daca nu e de aceeasi parte ...
                {
                    eliminare (j);   //il elimin punand in locul lui ultimul punct
                    j--;             //revin un pas poate si cel pus in locul lui nu e bun
                }
    }
}

int main()
{
    int l, i;
    citire();
    for (l = 1; l <= nrl; l++)
    {
        M = G;                      //copiez grindina in manevra
        for (i = 1; i <= G; i++)
            m[i] = g[i];
        for (i = 1; i <= nrp[l] + 2; i++) //copiez lotul in manevra
            LM[i] = L[l][i];
        numara (l);                //numar in M grindina cazuta pe lotul asta
        GpeL[l] = M;               //calculez cata grindina a cazut pe lotul l
        if (M>Mmax)
        {
            Mmax = M;
            cateMmax = 1;
        }
        else
            if (M == Mmax)
                cateMmax++;
        if (M == 0)
            cate0++;
    }
    fout << cateMmax << '\n';
    for (i = 1; i <= nrl; i++)
        if (GpeL[i] == Mmax)
            fout << i << ' ';
    fout << '\n';
    fout << cate0 << '\n';
    if (cate0)
    {
        for (i = 1; i <= nrl; i++)
            if (GpeL[i] == 0)
                fout << i << ' ';
    }
    else
        fout << "0\n";
    fout.close();
    return 0;
}
