//prof. Marinel Serban
//ianuarie 2014
//fac aceleasi verificari dar calculez pentru fiecare grindina cazuta
//daca suma ariilor formate de grindina cu fiecare latura a poligonului
//este egala cu aria poligonului... daca DA este inauntru

#include <fstream>
#include <cmath>

using namespace std;

long G, nrl;
long A, B, C;

struct pct        //record Punct
{
    int x, y;
};

typedef pct lot[101]; //retine structura lot

lot L[101];       //loturile
pct g[2000];      //retine grindina
int nrp[101];     //si cate puncte are fiecare
lot LM;           //lot manevra
long M;           //manevra
pct m[2000];      //manevra
int GpeL[101], cateMmax, cate0, Mmax;

ifstream fin ("grindina.in");
ofstream fout ("grindina.out");

void citire()
{
    int i, j;
    fin >> nrl;                   //cate loturi sunt
    for (i = 1; i <= nrl; i++)    //pentru fiecare lot
    {
        fin >> nrp[i];            //cate puncte il delimiteaza
        for (j = 1; j <= nrp[i]; j++) //citesc punctele
            fin >> L[i][j].x >> L[i][j].y;

        L[i][nrp[i] + 1] = L[i][1];  //adaug cele doua puncte
        L[i][nrp[i] + 2] = L[i][2];  //
    }
    fin >> G;                     //cata grindina
    for (i = 1; i <= G; i++)      //unde
        fin >> g[i].x >> g[i].y;
}

double dist (pct A, pct B)
{   //distanta dintre doua puncte
    return sqrt ( (double) ( (A.x - B.x) * (A.x - B.x) + (A.y - B.y) * (A.y - B.y)));
}

double S (double a, double b, double c)
{   //aria unui triunghi de laturi a, b, c
    double p = (a + b + c) / 2.0;
    return sqrt ( (double) (p * (p - a) * (p - b) * (p - c)));
}

double aria (int l)
{   //aria unui poligon convex
    double A = 0, a, b, c;
    int i;
    for (i = 2; i < nrp[l]; i++)
    {
        a = dist (LM[1], LM[i]);
        b = dist (LM[i], LM[i+1]);
        c = dist (LM[1], LM[i+1]);
        A += S (a, b, c);
    }
    return A;
}

int numara_cu_arii (int l, double Aria)
{
    int in_lot = 0, i, k, ok;
    double AriaL, a, b, c, A;
    for (i = 1; i <= M; ++i)
    {
        AriaL = 0.0;
        ok = 1;
        for (k = 1; k <= nrp[l]; k++)
        {
            a = dist (m[i], LM[k]);
            b = dist (LM[k], LM[k+1]);
            c = dist (m[i], LM[k+1]);
            A = S (a, b, c);
            if (A)
                AriaL += A;
            else
            {
                ok = 0;
                break;
            }
        }
        if (fabs (Aria - AriaL) < 0.0001 && ok)
            in_lot++;
    }
    return in_lot;
}

int main()
{
    int l, i, CareLot;
    double Aria, AriaM;
    citire();
    for (l = 1; l <= nrl; l++)
    {
        M = G;                      //copiez grindina in manevra
        for (i = 1; i <= G; i++)
            m[i] = g[i];
        for (i = 1; i <= nrp[l] + 2; i++) //copiez lotul in manevra
            LM[i] = L[l][i];
        Aria = aria (l);            //determin aria lotului
        M = numara_cu_arii (l, Aria); //numar in M grindina cazuta pe lotul asta
        GpeL[l] = M;               //calculez cata grindina a cazut pe lotul l
        if (M>Mmax)
        {
            Mmax = M;
            cateMmax = 1;
        }
        else
            if (M == Mmax)
                cateMmax++;
        if (M == 0)
            cate0++;
    }
    fout << cateMmax << '\n';
    for (i = 1; i <= nrl; i++)
        if (GpeL[i] == Mmax)
            fout << i << ' ';
    fout << '\n';
    fout << cate0 << '\n';
    if (cate0)
    {
        for (i = 1; i <= nrl; i++)
            if (GpeL[i] == 0)
                fout << i << ' ';
    }
    else
        fout << "0\n";

    fout.close();
    return 0;
}
