#include <stdio.h>
#define NMax 100005
#define MMax 100005
#define VMax 200000

int n, m;
int h[NMax], q[MMax];
int occ1[VMax];
int occ2[VMax];

int main() {
	freopen("colina.in", "rt", stdin);
	freopen("colina.out", "wt", stdout);

	int vmax = 0;
	scanf("%d %d", &n, &m);

	for (int i = 1; i <= n; i++) {
		scanf("%d", &h[i]);
		if (vmax < h[i]) {
			vmax = h[i];
		}
	}

	for (int i = 0; i < m; i++) {
		scanf("%d", &q[i]);
	}

	if (vmax > VMax) {
		// O(N x M) time, O(N) memory  -  brute

		for (int i = 0; i < m; i++) {

			int found = 0;
			for (int j = 1; j <= n; j++) {
				if (h[j] == q[i]) {
					if (!found) {
						printf("DA %d", j);
					} else {
						printf(" %d", j);
					}
					found = 1;
				}
			}
			if (!found) {
				printf("NU");
			}
			printf("\n");
		}
	} else {
		// O(N + M) time, O(N + VMax) memory  -  array of occurences

		for (int i = 1; i <= n; i++) {
			if (occ1[h[i]]) {
				occ2[h[i]] = i;
			} else {
				occ1[h[i]] = i;
			}
		}

		for (int i = 0; i < m; i++) {
			if (q[i] > VMax) {
				printf("NU\n");
				continue;
			}
			if (occ2[q[i]]) {
				printf("DA %d %d\n", occ1[q[i]], occ2[q[i]]);
			} else if (occ1[q[i]]) {
				printf("DA %d\n", occ1[q[i]]);
			} else {
				printf("NU\n");
			}
		}
	}

	fclose(stdin);
	fclose(stdout);
	return 0;
}

