#include <stdio.h>
#define NMax 100005

int n, m;
int h[NMax], q;

int ternarySearch(int low, int high) {

	while (high - low >= 3) {
		int mi1 = low + (high - low) / 3;
		int mi2 = low + 2 * (high - low) / 3;

		if (h[low] < h[mi1] && h[mi1] < h[mi2]) {
			low = mi1;
			continue;
		}

		if (h[mi1] > h[mi2] && h[mi2] > h[high]) {
			high = mi2;
		}
	}

	while (h[low] < h[low + 1]) {
		low++;
	}
	return low;
}

int binarySearch(int val, int low, int high) {

	while (high - low > 1) {
		int mi = (low + high) / 2;
		if ((h[low] < h[low + 1] && val < h[mi]) ||
			(h[low] > h[low + 1] && val > h[mi])) {
				high = mi;
		} else {
			low = mi;
		}
	}

	if (h[low] == val) {
		return low;
	}
	if (h[high] == val) {
		return high;
	}
	return -1;
}

int main() {

	freopen("colina.in", "rt", stdin);
	freopen("colina.out", "wt", stdout);

	scanf("%d %d", &n, &m);

	for (int i = 0; i < n; i++) {
		scanf("%d", &h[i]);
	}
	// this is not necessary - O(N) would be the same here
	int pos = ternarySearch(0, n - 1);

	for (int i = 0; i < m; i++) {

		scanf("%d", &q);
		
		int posSmall = binarySearch(q, 0, pos);
		int posBig = binarySearch(q, pos + 1, n - 1);

		if (posSmall != -1 && posBig != -1) {
			printf("DA %d %d\n", posSmall + 1, posBig + 1);
		} else if (posSmall != -1) {
			printf("DA %d\n", posSmall + 1);
		} else if (posBig != -1) {
			printf("DA %d\n", posBig + 1);
		} else {
			printf("NU\n");
		}
	}

	fclose(stdin);
	fclose(stdout);
	return 0;
}
